registry = "911551088899.dkr.ecr.us-east-1.amazonaws.com"
service = getMsName()


pipeline {
    agent none
  stages {
    stage("Build Image"){
        agent any
        steps{
            echo registry
            echo service
            echo  registry + "/" + service + ":rc-" + BUILD_NUMBER
            sh " docker build . -t  ${registry}/${service}:rc-${BUILD_NUMBER}"
        }
    }
    stage('Login to ecr') {
        agent any
        steps {
            script{  
                echo service            
                withAWS(region:'us-east-1', credentials:'jenkins-user') {
                    sh " aws ecr get-login-password | docker login  -u AWS --password-stdin  ${registry}"
                }
            }
        }
    }
    stage('push image') {
        agent any
        steps {
            script{  
                echo service            
                withAWS(region:'us-east-1', credentials:'jenkins-user') {
                    sh "docker push ${registry}/${service}:rc-${BUILD_NUMBER} "
                }
            }
        }
    }
    stage('package and push helm chart') {
        agent any
        steps {
            script{
                sh "ls -l"  
                dir("${WORKSPACE}/helm"){ 
                sh "ls -l"             
                withEnv(['HELM_EXPERIMENTAL_OCI=1']){          
                withAWS(region:'us-east-1', credentials:'jenkins-user') {
                    // read values yaml and update image tag
                    def valuesYaml = readYaml file: "values.yaml"
                    echo "values before:" + valuesYaml
                    valuesYaml.deployment.image.tag = "rc-" + BUILD_NUMBER
                    writeYaml file: 'values.yaml' , data: valuesYaml , overwrite: true
                    echo "values after:" + valuesYaml
                    
                    // read chart yaml and update image tag
                    def chartYaml = readYaml file: "Chart.yaml"
                    echo "values before:" + chartYaml
                    currentVersion = chartYaml.version
                    newVersion = currentVersion + "-rc-" + BUILD_NUMBER
                    chartYaml.version = newVersion
                    writeYaml file: 'Chart.yaml' , data: chartYaml , overwrite: true
                    echo "values after:" + chartYaml

                    sh " aws ecr get-login-password | helm registry login  -u AWS --password-stdin  ${registry}"
                    sh "rm -rf *tgz"
                    sh " helm package ."
                    sh " helm push *.tgz oci://${registry}"
                }
                }
            }
        }
    }
    }

  }
}

void getMsName(){
    MsName = JOB_NAME.replace("googlems/","").replace("/main","")
    echo MsName
    return MsName
}
